# TODO: fix autoreconf
# define with_reconf 0

# TODO: add aix-soname support
%define with_svr4_support 1

Name: libjpeg-turbo
Version: 1.5.1
Release: 1
License: BSD
Summary: JPEG library
Url: http://libjpeg-turbo.org/

%if %{with reconf}
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool
%endif

Source0: https://downloads.sourceforge.net/project/libjpeg-turbo/%{version}/libjpeg-turbo-%{version}.tar.gz


%description
libjpeg-turbo is a JPEG image codec that uses SIMD instructions (MMX, SSE2, AVX2, NEON, AltiVec) to accelerate baseline JPEG compression and decompression on x86, x86-64, ARM, and PowerPC systems. On such systems, libjpeg-turbo is generally 2-6x as fast as libjpeg, all else being equal. On other types of systems, libjpeg-turbo can still outperform libjpeg by a significant amount, by virtue of its highly-optimized Huffman coding routines. In many cases, the performance of libjpeg-turbo rivals that of proprietary high-speed JPEG codecs. 

%package -n libjpeg8
Summary: libjpeg library

%description -n libjpeg8
JPEG libraries

%package -n libturbojpeg0
Summary: libturbojpeg library

%description -n libturbojpeg0
Turbo JPEG libraries

%package devel
Summary: libjpeg development files
Requires: libturbojpeg0 = %{version}
Requires: libjpeg8 = %{version}

%description devel
libjpeg development files

%prep
%setup -q

%build

%if %{with reconf}
autoreconf -fi
%else
%define _host powerpc-ibm-aix6
%endif

# libtool "compile" wrapper seems to have a bug when linking
# as it eats the -o option even if there's no -c option passed.
# This results in the following error:
#
# link: ../compile gcc -shared -Wl,-G -o .libs/libjpeg.so.8.d/shr_64.o
# libtool: link: strip -e .libs/libjpeg.so.8.d/shr_64.o
# strip: .libs/libjpeg.so.8.d/shr_64.o -- 0654-400 Cannot open file.
#
# Due to the previous compile command eating the -o, but not actually
# renaming the a.out to the -o output parameter - it does an exec of the
# modified command instead.
#
# We work around it here, by just generating a new compile command which
# just executes whatever it was given. That's fine because the compile
# is just a wrapper for compilers which don't understand the -o, which
# gcc of course does and is superflous in this case.

mv compile compile.orig
cat <<EOF > compile
#!/bin/sh
exec "\$@"
EOF
chmod +x compile

%configure \
  LDFLAGS="-maix${OBJECT_MODE} -Wl,-brtl -Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib -L%{_libdir}" \
%if %{with svr4_support}
  --with-aix-soname=svr4 \
%endif
  --disable-static \
  --with-jpeg8 \
  --without-java \
  # end
  
%make_build


%install

%make_install

find %{buildroot}/%{_libdir} -name \*.la | xargs rm


%files
%defattr(-, qsys, *none)

%{_bindir}/jpegtran
%{_bindir}/djpeg
%{_bindir}/rdjpgcom
%{_bindir}/cjpeg
%{_bindir}/wrjpgcom
%{_bindir}/tjbench

%{_mandir}/man1/jpegtran.1
%{_mandir}/man1/wrjpgcom.1
%{_mandir}/man1/cjpeg.1
%{_mandir}/man1/djpeg.1
%{_mandir}/man1/rdjpgcom.1

%{_docdir}/libjpeg-turbo/usage.txt
%{_docdir}/libjpeg-turbo/LICENSE.md
%{_docdir}/libjpeg-turbo/libjpeg.txt
%{_docdir}/libjpeg-turbo/structure.txt
%{_docdir}/libjpeg-turbo/wizard.txt
%{_docdir}/libjpeg-turbo/example.c
%{_docdir}/libjpeg-turbo/README.ijg
%{_docdir}/libjpeg-turbo/README.md

%files -n libjpeg8
%defattr(-, qsys, *none)

%{_libdir}/libjpeg.so.8

%files -n libturbojpeg0
%defattr(-, qsys, *none)

%{_libdir}/libturbojpeg.so.0

%files devel
%defattr(-, qsys, *none)

%{_libdir}/libjpeg.so
%{_libdir}/libturbojpeg.so

%{_libdir}/pkgconfig/libturbojpeg.pc
%{_libdir}/pkgconfig/libjpeg.pc

%{_includedir}/jmorecfg.h
%{_includedir}/jconfig.h
%{_includedir}/turbojpeg.h
%{_includedir}/jerror.h
%{_includedir}/jpeglib.h


%changelog
